=== docs/cheatsheet/Makefile ===
all: python.pdf

%.pdf: %.tex
	pdflatex -interaction=nonstopmode $<
