=== debian/changelog ===
casadi (3.7.0+ds2-3) unstable; urgency=medium

  * Add missing info to debian/copyright.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 01:18:12 +0200

casadi (3.7.0+ds2-2) unstable; urgency=medium

  * Build ipopt plugin.
  * Fixes to library handling.

 -- Roland Mas <lolando@debian.org>  Fri, 01 Aug 2025 23:06:17 +0200

casadi (3.7.0+ds2-1) unstable; urgency=medium

  * Unvendor everything. See git history for how to undo that if more
    plugins need to be compiled in.
  * Reimport from upstream, filtering out the external_packages libs.

 -- Roland Mas <lolando@debian.org>  Mon, 14 Jul 2025 16:25:10 +0200

casadi (3.7.0+ds1-1) unstable; urgency=medium

  * Use system-provided libtinyxml2.
  * Use system-provided libdsdp.
  * Use system-provided libipopt.
  * Complete debian/copyright.
  * Reimport from upstream, filtering out the unvendored libs.

 -- Roland Mas <lolando@debian.org>  Wed, 09 Jul 2025 17:30:13 +0200

casadi (3.7.0-1) unstable; urgency=medium

  * Initial release. (Closes: #745758).

 -- Roland Mas <lolando@debian.org>  Tue, 24 Jun 2025 16:26:16 +0200
