=== debian/control ===
Source: casadi
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>,
 Roland Mas <lolando@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 chrpath,
 cmake,
 debhelper-compat (= 13),
 libdsdp-dev,
 coinor-libipopt-dev,
 liblapack-dev,
 libtinyxml2-dev,
 pkgconf,
 python3-all,
 python3-all-dev,
 python3-matplotlib,
 python3-numpy,
 python3-scipy,
 python3-setuptools,
 swig,
Standards-Version: 4.6.2
Homepage: https://casadi.org
Vcs-Browser: https://salsa.debian.org/science-team/casadi
Vcs-Git: https://salsa.debian.org/science-team/casadi.git

Package: casadi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Nonlinear optimization and algorithmic differentiation
 CasADi is an open-source tool for nonlinear optimization and
 algorithmic differentiation.  It facilitates rapid — yet efficient —
 implementation of different methods for numerical optimal control,
 both in an offline context and for nonlinear model predictive control
 (NMPC).
 .
 This package contains the main binaries.

Package: libcasadi3.7
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Nonlinear optimization and algorithmic differentiation
 CasADi is an open-source tool for nonlinear optimization and
 algorithmic differentiation.  It facilitates rapid — yet efficient —
 implementation of different methods for numerical optimal control,
 both in an offline context and for nonlinear model predictive control
 (NMPC).
 .
 This package contains the libraries.

Package: libcasadi-dev
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Nonlinear optimization and algorithmic differentiation - development files
 CasADi is an open-source tool for nonlinear optimization and
 algorithmic differentiation.  It facilitates rapid — yet efficient —
 implementation of different methods for numerical optimal control,
 both in an offline context and for nonlinear model predictive control
 (NMPC).
 .
 This package contains the development files.

Package: python3-casadi
Architecture: any
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Nonlinear optimization and algorithmic differentiation - Python bindings
 CasADi is an open-source tool for nonlinear optimization and
 algorithmic differentiation.  It facilitates rapid — yet efficient —
 implementation of different methods for numerical optimal control,
 both in an offline context and for nonlinear model predictive control
 (NMPC).
 .
 This package contains the Python bindings.
