=== debian/rules ===
#!/usr/bin/make -f

export WITH_PYTHON3=yes

%:
	dh $@

CONFIG_SWITCHES=-DWITH_PYTHON=ON -DWITH_PYTHON3=ON -DWITH_BUILD_TINYXML=OFF -DWITH_BUILD_DSDP=OFF -DWITH_BUILD_IPOPT=OFF -DWITH_CSPARSE=OFF -DWITH_SUNDIALS=OFF -DWITH_FMI2=OFF -DWITH_FMI3=OFF -DWITH_IPOPT=ON

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIG_SWITCHES)

execute_after_dh_auto_install:
	find debian -name *.so -print0 | xargs -0 chrpath -d
	find debian -name *.so.* -print0 | xargs -0 chrpath -d
	find debian/*/usr/bin -type f -print0 | xargs -0 chrpath -d

override_dh_auto_test:
	make -C test
