=== debian/watch ===
version=4

opts="mode=git,dversionmangle=auto,uversionmangle=s/rc/~rc/,repacksuffix=+ds2,repack" \
https://github.com/casadi/casadi refs/tags/v?([\d.]+)
